\chapter{Software Testing}
To ensure the “Resume Classification and Candidate Application Tracking System” project is reliable, accurate, and performs well, various types of testing should be conducted.
Each type of testing addresses different aspects of the system, from individual components to the entire application. \\
Below are some ket types of testing that should are conducted:

\begin{table}[ht]
    \small
    \centering
    \begin{tabularx}{\textwidth}{|p{1cm}|>{\centering\arraybackslash}X|>{\RaggedRight\arraybackslash}X|>{\RaggedRight\arraybackslash}X|p{2cm}|>{\centering\arraybackslash}X| >{\centering\arraybackslash}X| >{\centering\arraybackslash}X|}
    \hline
    \textbf{Test ID} & \textbf{Test Description} & \textbf{Step Details} & \textbf{Expected Results} & \textbf{Actual Results} & \textbf{Pass/Fail} \\
    \hline
    UT01 & Unit testing for NER model & 1. Load the Llama2 model \newline 2. Input sample resume text \newline 3. Run NER extraction function & Extracted entities should match the annotated entities in the sample text & The extracted entities match with the annotated entities & Pass \\
    \hline
    UT02 & Unit testing for database operations & 1. Perform CRUD operations on a test database 2. Verify data integrity and consistency & Database operations should execute successfully without data corruption & Database operations executes without any error and data corruption & Pass \\
    \hline
    UT03 & Unit testing for API endpoints & 1. Send mock API request for each endpoint 
    \newline 2. Verify responses and status codes & Response should match the expected output and return appropriate status code & Obtained response matches with the predicted output and appropriate status code is received & Pass \\
    \hline
    \end{tabularx}
    \caption{Unit Testing}
    \label{tab:my_table}
\end{table}

\begin{table}[ht]
    \small
    \centering
    \begin{tabularx}{\textwidth}{|p{1cm}|>{\centering\arraybackslash}X|>{\RaggedRight\arraybackslash}X|>{\RaggedRight\arraybackslash}X|p{2cm}|>{\centering\arraybackslash}X| >{\centering\arraybackslash}X| >{\centering\arraybackslash}X|}
    \hline
    \textbf{Test ID} & \textbf{Test Description} & \textbf{Step Details} & \textbf{Expected Results} & \textbf{Actual Results} & \textbf{Pass/Fail} \\
    \hline
    IT01 & 
    Integration testing for API and DB & 
    1. Send resume data through API \newline
    2. Extract entities and store in Chroma \newline
    3. Retrieve data & 
    Data retrieved from the database should match the extracted entities & Entities retreived from database matches exactly with the obtained entities & Pass \\
    \hline
    
    IT02 & 
    Integration testing for Frontend-Backend interaction & 
    1. Submit resume data through frontend interface \newline
    2. Verify backend processes data correctly \newline
    3. Check if frontend displays updated data &
    Data flow between frontend and backend should be seamless and accurate & Accurate flow of data & Pass \\
    \hline
    
    IT03 & 
    Integration testing for external services & 
    1. Testing integration with external platforms (eg., email services, cloud storage) \newline
    2. Verify data exchange and functionality & 
    Integration should work smoothly without errors or data loss & Errors occurred were resolved leading to smmoth working of the system & Pass \\
    \hline
    \end{tabularx}
    \caption{Integration Testing}
    \label{tab:my_table}
\end{table}

\begin{table}[ht]
    \small
    \centering
    \begin{tabularx}{\textwidth}{|p{1cm}|>{\centering\arraybackslash}X|>{\RaggedRight\arraybackslash}X|>{\RaggedRight\arraybackslash}X|p{2cm}|>{\centering\arraybackslash}X| >{\centering\arraybackslash}X| >{\centering\arraybackslash}X|}
    \hline
    \textbf{Test ID} & \textbf{Test Description} & \textbf{Step Details} & \textbf{Expected Results} & \textbf{Actual Results} & \textbf{Pass/Fail} \\
    \hline
    
    FT01 & 
    Functional testing for resume upload&
    1. Open frontend \newline
    2. Upload a resume \newline
    3. Verify extracted entities are displayed correctly & 
    Entities should be accurately displayed in the frontend & All recognized entities were accurately displayed on front-end & Pass \\
    \hline
    
    FT02 & 
    Functional testing for search feature & 
    1. Enter search query (eg., job title, skill) \newline
    2. Verify returned results match the query &
    Resumes matching search criteria should be displayed & Eligible candidates which match the criteria were successfully displayed & Pass \\
    \hline
    
    FT03 & 
    Functional testing for chat feature & 
    1. Initiate conversation with a resume \newline
    2. Ask questions about candidate’s profile \newline
    3. Verify responses are accurate &
    Chat responses should provide relevant information about the candidate & Chat response provides relevant information as expected & Pass \\
    \hline
    \end{tabularx}
    \caption{Functional Testing}
    \label{tab:my_table}
\end{table}

\begin{table}[ht]
    \small
    \centering
    \begin{tabularx}{\textwidth}{|p{1cm}|>{\centering\arraybackslash}X|>{\RaggedRight\arraybackslash}X|>{\RaggedRight\arraybackslash}X|p{2cm}|>{\centering\arraybackslash}X| >{\centering\arraybackslash}X| >{\centering\arraybackslash}X|}
    \hline
    \textbf{Test ID} & \textbf{Test Description} & \textbf{Step Details} & \textbf{Expected Results} & \textbf{Actual Results} & \textbf{Pass/Fail} \\
    \hline
    
    PT01 &
    Performance testing for load & 
    1. Simulate 100 concurrent users uploading resumes \newline
    2. Monitor response time & 
    System should handle the load with acceptable response time & System handels the load with minimum response time & Pass \\
    \hline
    
    PT02 & 
    Performance testing for scalability & 
    1. Gradually increase the number of concurrent users \newline
    2. Monitor system resources and performance & 
    System should scale horizontally to accommodate increased load & Achieved hotizontal scaling of the system & Pass \\
    \hline
    
    PT03 & 
    Performance testing for database &
    1. Execute multiple concurrent database queries \newline
    2. Measure query response time and throughput & 
    Database should handle concurrent queries without performance degradation & Database is able to handle concurrent queries without any delay & Pass \\
    \hline

    \end{tabularx}
    \caption{Performance Testing}
    \label{tab:my_table}
\end{table}

\begin{table}[ht]
    \small
    \centering
    \begin{tabularx}{\textwidth}{|p{1cm}|>{\centering\arraybackslash}X|>{\RaggedRight\arraybackslash}X|>{\RaggedRight\arraybackslash}X|p{2cm}|>{\centering\arraybackslash}X| >{\centering\arraybackslash}X| >{\centering\arraybackslash}X|}
    \hline
    \textbf{Test ID} & \textbf{Test Description} & \textbf{Step Details} & \textbf{Expected Results} & \textbf{Actual Results} & \textbf{Pass/Fail} \\
    \hline
    
    ST01 & 
    Security testing for SQL injection & 
    1. Input malicious SQL code into the resume upload form \newline
    2. Submit the form & 
    System should reject the input and remain secure & SQL injection does not affect the system. & Pass \\
    \hline
    
    ST02&
    Security testing for authentication&
    1. Attempt to access restricted resources without proper authentication \newline
    2. Check access control measures&
    Unauthorised access should be prevented, and access controls should be enforced & Unauthorized access is prevented successfully & Pass \\
    \hline
    
    ST03&
    Security testing for data privacy&
    1. Check for sensitive data exposure in logs or error messages \newline
    2. Verify data encryption measures&
    Sensitive data should be properly encrypted and protected from exposure & Sensitive data are hashed and stored securely & Pass \\
    \hline
    
    \end{tabularx}
    \caption{Security Testing}
    \label{tab:my_table}
\end{table}

\begin{table}[ht]
    \small
    \centering
    \begin{tabularx}{\textwidth}{|p{1cm}|>{\centering\arraybackslash}X|>{\RaggedRight\arraybackslash}X|>{\RaggedRight\arraybackslash}X|p{2cm}|>{\centering\arraybackslash}X| >{\centering\arraybackslash}X| >{\centering\arraybackslash}X|}
    \hline
    \textbf{Test ID} & \textbf{Test Description} & \textbf{Step Details} & \textbf{Expected Results} & \textbf{Actual Results} & \textbf{Pass/Fail} \\
    \hline
    UT01&
    Usability testing for interface&
    1. Observe users navigating the UI \newline
    2. Note any difficulties \newline
    3. Collect user feedback &
    Users should navigate the interface easily and efficiently & User interface is easy to navigate & Pass \\
    \hline
    \end{tabularx}
    \caption{Usability Testing}
    \label{tab:my_table}
\end{table}
